"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CodeMirror = require("codemirror/addon/runmode/runmode.node");
var charactersToEncode = {
    "&": "&amp;",
    "<": "&lt;",
    ">": "&gt;",
};
var encodeCharacter = function (chr) {
    return charactersToEncode[chr] || chr;
};
var encodeText = function (str) {
    return str.replace(/[&<>]/g, encodeCharacter);
};
require("codemirror/mode/meta");
CodeMirror.modeInfo.forEach(function (element) {
    if (Object.keys(element).some(function (x) { return element[x] === "null"; }))
        return;
    var mode = element["mode"];
    var required = "codemirror/mode/" + mode + "/" + mode;
    require(required);
});
require("./graphqlMode");
function highlightCode(language, value) {
    var elements = [];
    var lastStyle = null;
    var tokenBuf = "";
    var pushElement = function (token, style) {
        elements.push("<span" + (style ? " class=\"cm-" + style + "\"" : "") + ">" + encodeText(token) + "</span>");
    };
    CodeMirror.runMode(value, language, function (token, style) {
        if (lastStyle === style) {
            tokenBuf += token;
            lastStyle = style;
        }
        else {
            if (tokenBuf) {
                pushElement(tokenBuf, lastStyle);
            }
            tokenBuf = token;
            lastStyle = style;
        }
    });
    pushElement(tokenBuf, lastStyle);
    return elements.join("");
}
exports.default = highlightCode;
