"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
var highlightCode_1 = __importDefault(require("./highlightCode"));
exports.default = (function (_a, _b) {
    var markdownAST = _a.markdownAST;
    var _c = _b === void 0 ? {} : _b, theme = _c.theme, className = _c.className;
    theme = theme || "default";
    unist_util_visit_1.default(markdownAST, "code", function (node) {
        var language = node.lang;
        // Replace the node with the markup we need to make
        // 100% width highlighted code lines work
        node.type = "html";
        node.value = "<div class=\"gatsby-highlight\" data-language=\"" + language + "\">\n      <pre class=\"" + (className || "") + " " + (theme ? "cm-s-" + theme : "") + "\"><code>" + highlightCode_1.default(language, node.value) + "</code></pre>\n    </div>";
    });
});
